#!/usr/bin/env python
#===========================================================================
#RTC Connector Module using Python
#===========================================================================
#Author:
#Written by Takayuki Sugawara, Univ of Tsukuba
#===========================================================================
#Version Information: 2007/12/10
#Ver. 1.0: Convert the ConnectorComp program(C++ Version) to Python
#===========================================================================
#Explanation about this module:
#This module provides you to control the RT Component using the python.
#===========================================================================

import sys
savepath = sys.path
sys.path.append("../../common/")

from Connector_Header import *

#-------------------------------------------------------------
def get_comp_info():
    for j in range(len(comp_lists)):
	i = 0
	Components[j] = a.GetObjectReference(comp_lists[j+1])
	Lists[j]  = a.GetPortsObject(Components[j])
	Activity[j]  = a.GetExecutionContextServices(Components[j])

	print '\n----------------------------------------'
	print 'Component[',j,'] = [',a.GetComponentProfile(Components[j]).type_name,']'
	print '----------------------------------------'
	
	print 'PortLists of the [',comp_lists[j+1],'] are as follows\n'
	for p in Lists[j]:
	    print 'con_in',j+1,'[',i,'] =',p.get_port_profile().name
	    i = i+1
	print '\n'
#-------------------------------------------------------------


a = RTCConnector()

# Please write your naming service
#=================================================
a.Connect2Nameservice("ufrg01.a02.aist.go.jp:2809")
#=================================================
a.GetComponentLists()


# Please write your component lists in "comp_lists"
#=================================================
comp_lists = { 1:'MyServiceProvider0', 2:'MyServiceConsumer0' }
#=================================================

get_comp_info()


# Please ready the connect
#=================================================
con_in  = Lists[0] # con_in  = port of 'MyServiceProvider0'
con_in2 = Lists[1] # con_in2 = port of 'MyServiceConsumer0'


# Connect
#=================================================
a.PortConnect(con_in[0],con_in2[0])
# con_in[0]  = ServiceProviderport of 'MyServiceProvider0'
# con_in2[0] = ServiceConsumerport of 'MyServiceConsumer0'


# Disconnect
#=================================================
#a.PortDisconnect(con_in[0])


# Please ready the activate
#=================================================
act_in  = Activity[0] # act_in = MyServiceProvider0
act_out = Activity[1] # act_out= MyServiceConsumer0


# Activate
#=================================================
act_in[0].activate_component(Components[0])
act_out[0].activate_component(Components[1])


# Deactivate
#=================================================
#act_in[0].deactivate_component(Components[0])
#act_out[0].deactivate_component(Components[1])
